#pragma once
#include "DTV_Base.h"
#include "../lib/CyAPI.h"
#include <list>

#define DTV_EzUSBFX2_ASYNC_XFER_REQ_NUM		32
#define DTV_EzUSBFX2_ASYNC_XFER_SIZE		0x8000

class CDTV_EzUSBFX2 : public CDTV_Base
{
public:
	CDTV_EzUSBFX2();
	virtual ~CDTV_EzUSBFX2(void);

	BOOL Initialize(char *szInitString=NULL,HWND hWnd=NULL,GUID *pGuid=NULL);
	void Release();
	BOOL IsInitialized();

	DWORD GetExtFunction();
	DWORD GetDeviceCount();
	BOOL GetDeviceName(int iDevNo,char *lpszDevName,int iBufLen);
	DWORD GetUsbEndpointCount(int iDevNo);
	BOOL GetUsbEndpointInfo(int iDevNo,int iUsbEpNo,struct DTV_UsbEndpointInfo *pUsbEpInfo);
	BOOL IsEndpointEffective(int iDevNo,int iUsbEpAddr);

	BOOL Connect(int iDevNo,int iInEpAddr,int iOutEpAddr);
	void DisConnect();
	BOOL IsConnect();

	DWORD XferRequestProc(struct DTV_ThreadParam *lpParameter);
	DWORD XferResponceProc(struct DTV_ThreadParam *lpParameter);

public:
	// pNXƎ
	void SetHvMikittyInit(BOOL bFlg)
	{
		m_bHvMikittyInit=bFlg;
	}

protected:	
	// Jnp[^
	struct DTV_EzUSBFX2_ReqParam
	{
		CCyUSBEndPoint	*pEP_In;
		CCyUSBEndPoint	*pEP_Out;
	};
	// 񓯊]L[
	struct DTV_EzUSBFX2_Request
	{
		OVERLAPPED		Overlap;
		CCyUSBEndPoint	*pEndPoint;
		PUCHAR			pContext;

		BYTE buf[DTV_EzUSBFX2_ASYNC_XFER_SIZE];
		LONG buf_len; 
	};

	CCyUSBDevice *m_pCyUSB;								// CypressėpCu
	std::list<struct DTV_EzUSBFX2_Request*>	m_ReqWait;	// NGXg\
	std::list<struct DTV_EzUSBFX2_Request*>	m_ReqBusy;	// NGXg
	CRITICAL_SECTION m_stCS;
	BOOL m_bHvMikittyInit;

	BOOL MakeXferQueue();
	void FreeXferQueue();
};
